function solveLinearSystem % chol normal

global svModel;
global temporarelyDataNeeded;



% calculer le noyau
%===================================================================
if temporarelyDataNeeded.new_active>0 % on a ajoute un point
    if temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active)==0 % n'est pas un point qui revient de C
        % mise a jour des indices
        temporarelyDataNeeded.n_H = sort([temporarelyDataNeeded.n_H,temporarelyDataNeeded.free(1)]);
        temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active) = temporarelyDataNeeded.free(1);
        temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]);
        [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
        if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
        end
        % calcul des nouvelles valeurs de H
        new_valueH =kernelPol(svModel.kernel,...
            svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]), ...
            svModel.data.trainvec(:,temporarelyDataNeeded.new_active), ...
            svModel.data.trainlab([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]), ...
            svModel.data.trainlab(temporarelyDataNeeded.new_active)); % points dans l'ordre des donnees, donc de actif
        % valeurs pour G
        u = new_valueH(temporarelyDataNeeded.reverse);
        svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,...
            temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active)) = u;
        svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active),...
            temporarelyDataNeeded.n_H) = u';
       % derniere mise a jour
        temporarelyDataNeeded.free(1) = [];
        if isempty(temporarelyDataNeeded.free)
            temporarelyDataNeeded.free = max(temporarelyDataNeeded.n_H)+1;
        end
    else
        temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]);
        [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
        if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
        end
        temporarelyDataNeeded.boundedback=0;
    end

elseif temporarelyDataNeeded.new_active<0
    if length(find(temporarelyDataNeeded.inactive==-temporarelyDataNeeded.new_active))>0 % on a retir� un point
        remove = find(temporarelyDataNeeded.n_H==temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)); % place du point � enlever dans nH

        % suppression des valeurs
        svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,...
            temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
        svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),...
            temporarelyDataNeeded.n_H) = 0;
        svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,...
            temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
        svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),...
            temporarelyDataNeeded.n_H) = 0;

        % mise a jours des indices
        temporarelyDataNeeded.free = sort([temporarelyDataNeeded.free,...
            temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)]);
        temporarelyDataNeeded.n_H(remove)=[];
        temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative([temporarelyDataNeeded.active;...
            temporarelyDataNeeded.bounded]);
        [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
        if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
        end
        temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active) = 0;
    else
        %remove = find(temporarelyDataNeeded.n_H==temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)); % place du point � enlever dans nH
        temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative([temporarelyDataNeeded.active;...
            temporarelyDataNeeded.bounded]);
        [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
        if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
        end
    end
end



% repartition des valeurs du noyau entre les libres et les bornes
temporarelyDataNeeded.n_Ha = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.active));
temporarelyDataNeeded.n_Hb = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.bounded));
        
% temporarelyDataNeeded.n_Ha = sort(temporarelyDataNeeded.n_H(temporarelyDataNeeded.inverse...
%    (1:length(temporarelyDataNeeded.active))));
% temporarelyDataNeeded.n_Hb = sort(temporarelyDataNeeded.n_H(temporarelyDataNeeded.inverse...
%     (end-length(temporarelyDataNeeded.bounded)+1:end)));
inverser = 0;
    try
        [svModel.model.G2{svModel.model.iclass}(fliplr(temporarelyDataNeeded.n_H),fliplr(temporarelyDataNeeded.n_H)),testchol] = ...
            chol(svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)+...
            svModel.data.trainlab(temporarelyDataNeeded.n_H)*...
            svModel.data.trainlab(temporarelyDataNeeded.n_H)');
    catch
        [svModel.model.G2{svModel.model.iclass}(fliplr(temporarelyDataNeeded.n_H),fliplr(temporarelyDataNeeded.n_H)),testchol] = ...
            chol(svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)+...
            svModel.data.trainlab(temporarelyDataNeeded.n_H)*...
            svModel.data.trainlab(temporarelyDataNeeded.n_H)'+...
            svModel.param.gap*eye(length(temporarelyDataNeeded.n_H)));
    end


% mettre les elements dans l'ordre de H!!
if length(svModel.param.span)>0
    A = (svModel.data.trainlab(temporarelyDataNeeded.active)*ones(1,temporarelyDataNeeded.n_active))*svModel.param.span(temporarelyDataNeeded.active,:);
    %be = zeros(size(svModel.param.span,2),1);
    A = A(temporarelyDataNeeded.reverse(temporarelyDataNeeded.inverse(1:temporarelyDataNeeded.n_active),:));
else
    A = svModel.data.trainlab([temporarelyDataNeeded.active]);%; temporarelyDataNeeded.bounded]);
    [a b] = sort(temporarelyDataNeeded.inverse(1:temporarelyDataNeeded.n_active));
    A = A(b);
    %be = 0;
end



ce = ones(1,temporarelyDataNeeded.n_active);
% if temporarelyDataNeeded.n_bounded > 0
%    ce= ce - svModel.param.C(1)*(sum(svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Hb,temporarelyDataNeeded.n_Ha),1));
%     be= be - max(svModel.param.C)*sum(svModel.data.trainlab(temporarelyDataNeeded.bounded),1);
%   
% end

if inverser==0
%M = A'*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
%    (svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'\A));
svModel.model.mu{svModel.model.iclass} = (svModel.param.C(1)*temporarelyDataNeeded.n)\(ce*...
    (svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
    (svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'\ce')));
svModel.model.alpha{svModel.model.iclass}=...
    svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
    (svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'\...
    (ce'*svModel.model.mu{svModel.model.iclass}));
else
    Gt = inv(svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)+...
         svModel.data.trainlab(temporarelyDataNeeded.n_H)*...
            svModel.data.trainlab(temporarelyDataNeeded.n_H)');
    %M = A'*Gt*A;
    svModel.model.mu{svModel.model.iclass} = (svModel.param.C(1)*temporarelyDataNeeded.n)\(ce*Gt*ce');
    svModel.model.alpha{svModel.model.iclass} = Gt*(ce*svModel.model.mu{svModel.model.iclass});
    inverser = 0;
end
% remettre alpha dans l'ordre de l'active set
[a b] = sort(temporarelyDataNeeded.inverse(1:temporarelyDataNeeded.n_active));
[c d] = sort(b);
svModel.model.alpha{svModel.model.iclass} = ...
    svModel.model.alpha{svModel.model.iclass}(d);

%temporarelyDataNeeded.active
%svModel.model.alpha{svModel.model.iclass}
%svModel.model.mu{svModel.model.iclass}
% keyboard
% end
