function [bestP, bestC, bestO, maxPerf, performance] = crossvalidation(nbfolders,dataset,svmParameters, svmKernel, parameters, slacks,orders)

global svModel;
% cross validation code
n = length(dataset.trainlab);
for i = 1:nbfolders
    no = 0;
    donnees.trainvec = dataset.trainvec(:,[1:(i-1)*floor(n/nbfolders),(i)*floor(n/nbfolders):n]);
    donnees.trainlab = dataset.trainlab([1:(i-1)*floor(n/nbfolders),(i)*floor(n/nbfolders):n]);
    donnees.testvec = dataset.trainvec(:,[(i-1)*floor(n/nbfolders)+1:(i)*floor(n/nbfolders)]);
    donnees.testlab = dataset.trainlab([(i-1)*floor(n/nbfolders)+1:(i)*floor(n/nbfolders)]);
    for o = orders
        np = 0;
        no = no+1;
        svmKernel.degree = o;
        for p = parameters
            np = np+1;
            svmKernel.scale = p;
            svmKernel.sigma = p;
            nc = 0;
            for c = slacks
                nc = nc+1;
                svmParameters.C = c;
                if nc>1 | np>1 | no>1
                    trainSVM(donnees, svmKernel, svmParameters, svModel.model);
                else
                    trainSVM(donnees, svmKernel, svmParameters);
                end
                prediction=testSVM;
                perf(i,no,np,nc) = max(length(find(sign(svModel.data.testlab)==sign(prediction(:,1))))/length(prediction(:,1)),length(find(svModel.data.testlab==prediction(:,1)))/length(prediction(:,1)));
            end
        end
    end
end

svModel.data = dataset;


k = 0;
maxPerf = 0;
for o = 1:no
    for p = 1:np
        for c = 1:nc
            k = k+1;
            performance(k) = mean(perf(:,o,p,c));
            if performance(k)>maxPerf
                maxPerf = performance(k);
                bestP = parameters(p);
                bestC = slacks(c);
                bestO = orders(o);
            end
        end
    end
end