%
%   Launch this in order to check if everything is ok
%
%
function [] =  TestSanityCheck(method)

temps = cputime;
exclass(method)            ;%              | 2D SVM Classification problem 
cputime-temps
fprintf('2D SVM Classification problem is OK \n click on the figure to continue \n ');
waitforbuttonpress;

    
temps = cputime;                             
exclassCdiff (method)          ;%              | 2D SVM Classification problem with different C
cputime-temps
fprintf('2D SVM Classification problem with different C is OK \n click on the figure to continue \n ');
waitforbuttonpress;
                
temps = cputime;                 
exclass2(method)            ;%              | Comparing Gaussian Kernel and Polynomial Kernel on 2D
cputime-temps
fprintf('Comparing Gaussian Kernel and Polynomial Kernel on 2D is OK \n click on the figure to continue \n ');
waitforbuttonpress;
                                 
% exclass3            ;%              | 2D SVM Classification with Semiparametric models
                
temps = cputime;                  
exclassalphainit(method)    ;%              | Example of initialization of the Lagragian
cputime-temps
fprintf('Example of initialization of the Lagragian is OK \n click on the figure to continue \n ');
waitforbuttonpress;
                                 
% checkers_multiclass            ;%              | MultiClass on the checkers pb
                
temps = cputime;                  
checkers_multiclass(method)    ;%              | Example of initialization of the Lagragian
cputime-temps
fprintf('Example of multiclass on the checkers problem is OK \n click on the figure to continue \n ');
waitforbuttonpress;
%exclasscheckershaarkernel;%         | Comparing Haar Kernel and Gaussian Kernel on
                                
                                 
% exclassls                    ;%     | Example of large-scale classification problem
                                 
% exclassnpa                   ;%     | Example of SVM Classification Using NPA algorithm
                                  
% exclassrn                    ;%     | Regularization Networks for classifying the CheckerBoard
                                  
 % exclassrn1                   ;%     | SemiParametric Regularization Networks 
                
temps = cputime;                  
 exmulticlass(method)                 ;%     | Example of multiclass problem 
cputime-temps
fprintf('Multiclass problem is OK \n click on the figure to continue \n ');
waitforbuttonpress;      ;%     | SemiParametric Regularization Networks 

temps = cputime;                  
multicarpette(method)                 ;%     | Example of multiclass problem on carpette
cputime-temps
fprintf('Multiclass on Carpette problem is OK \n click on the figure to continue \n ');
waitforbuttonpress;      ;%     | SemiParametric Regularization Networks 
                
temps = cputime;                  
test1class(method)                 ;%     | Example of 1class Pb
cputime-temps
fprintf('1class problem is OK \n click on the figure to continue \n ');
waitforbuttonpress;
                
temps = cputime;                  
 exmulticlass1(method)                ;%     | Treating the example presented by Lin & Wahba and analysing
cputime-temps
fprintf('Treating the example presented by Lin & Wahba and analysing is OK \n click on the figure to continue \n ');
waitforbuttonpress;
                                  
 % exmulticlass2                ;%     | Treating another example with "one-against-one" algorithm
                                  
 % exmulticlass1v1              ;%     | Example of multiclass problem using
                                  
 % exmulticlassall              ;%     | M-SVM algorithm for treating the multiclasse problem
                                  
% exmulticlassall2             ;%     | Another M-SVM examples with assymetric penalization coefficients

% ------------------------- Regression---------------------------
 % exreg1d                      ;%     | 1D SVM Regression problem    
                                  
 % exreg2d                      ;%     | 2D SVM Regression problem 

% -------------------------- Feature Selection -------------------
% FeatSelAdaptScal             ;%     | Demo of the SVM adaptive scaling method of GrandValet & Canu
                                  
% FeatSelAdaptScal1            ;%     | Example of adaptive scaling as described in the NIPS paper  
                                  
% ---------------------------Kernel PCA -------------------------
 % kpcaex1                        ;%    | Simple Example of Kernel PCA on a artificial datasets
                                     
 % kpcaex2                        ;%    | Example of KPCA. this is a B.Scholkopf modified routine  
                                  
 % kpcaex3                        ;%    | Example of Multilayer SVM with a KPCA as a first stage

% % ------------------------- Wavelet Kernels ---------------------
% 
% % Need Wavelab Toolbox
% extensorwavkernel            ;%    | Example of the different possibility of wavelet kernel
%  
close all;