% mise en forme des données

load('../database/wipo.mat');
n = length(E);
adjacence = zeros(n,n);
for i=1:n-1
    adjacence(E(i,1),E(i,2)) = 1;
end
%imagesc(adjacence)
root = find(sum(adjacence,1)==0)';
leaves = find(sum(adjacence,2)==0)';

p=0.1;
ntr = size(Y_tr,1);
%ntr = 10
nts = size(Y_ts,1);
for i=1:ntr
    indices = find(Y_tr(i,:)==1)+1;
    adj = (adjacence(indices,indices));
    %leaf = indices(find(sum(adj,2)==0));
    ind = find(sum(adj,1)==0);
    root = indices(ind);
    path = [root];
    for j=2:length(indices)
        Y_tr(i,root-1) = Y_tr(i,root-1)*(j*p);
        ind = find(adj(ind,:)==1);
        root = indices(ind);
        path = [path,root];
    end
end

for i=1:nts
    indices = find(Y_tr(i,:)==1)+1;
    adj = (adjacence(indices,indices));
    %leaf = indices(find(sum(adj,2)==0));
    ind = find(sum(adj,1)==0);
    root = indices(ind);
    path = [root];
    for j=2:length(indices)
        Y_ts(i,root-1) = Y_ts(i,root-1)*(j*p);
        ind = find(adj(ind,:)==1);
        root = indices(ind);
        path = [path,root];
    end
end


X_tr = X_tr/(max(max(abs(X_tr))));
X_ts = X_ts/(max(max(abs(X_tr))));