function test(nbapp,nbtest)

global svModel;
%--------------------------------------------------
n='checkers';
% rand('seed',0);
[x,y,xt,yt,xtt,ytt] = dataset(n,nbapp,nbtest);
donnees = data(x,y,xt,yt);
clear x;
clear y;
clear xt;
clear yt;
clear xtt;
clear ytt;
multiclass='';


%-----------------------------------------------------
%   Learning Parameters
C = 500;
p = [3];
ker= 'rbf';
tolerance = 1e-5;
pas = 100;

meth = {'chol','qr','shmo'};
for i=1:3
parametres = param(C,pas,multiclass,meth{i},tolerance);
noyau = kernel(ker,p);
%-----------------------------------------------------
% Learning and testing
trainSVM(donnees,noyau,parametres);
prediction = testSVM;
perf = length(find(sign(donnees.testlab)==sign(prediction)))/length(prediction);
fprintf(1,'performance en test: %2.2f \n',100*perf);

%figure;
subplot(2,2,i);
hold on;
[xtesta1,xtesta2]=meshgrid([-2:0.05:2],[-2:0.05:2]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2];
svModel.data.testvec = xtest;
ypred = testSVM;
%[ypred,maxi]=OnLineSVM_1vs_all_val(d,alpha,pos,nbsv,b,yapp,xtest',xapp);
ypredmat=reshape(ypred,na,nb);
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 1],'k');
clabel(cs,h);
plot(donnees.trainvec(1,find(donnees.trainlab==1)),donnees.trainvec(2,find(donnees.trainlab==1)),'rx');
plot(donnees.trainvec(1,find(donnees.trainlab==-1)),donnees.trainvec(2,find(donnees.trainlab==-1)),'bx');
axis([-2 2 -2 2]);
hold off;

end

clear all

