 function test1class(method)

nbapp = 100;
nbtest = 100;
global svModel;
%--------------------------------------------------
x = 0.1*randn(2,nbapp);
xt =  [0.1*randn(2,nbtest/2), .4+0.15*randn(2,nbtest/2)];
y = ones(nbapp,1);
yt =  [ones(nbtest/2,1); -ones(nbtest/2,1)];
donnees = data(x,y,xt,yt);
multiclass='1class';


%-----------------------------------------------------
%   Learning Parameters
C = 50;
p = [10];
ker= 'rbf';
tolerance = 1e-5;
pas = 10;

%meth = 'qr'
parametres = param(C,pas,multiclass,method,tolerance);
noyau = kernel(ker,p);
%-----------------------------------------------------
% Learning and testing
trainSVM(donnees,noyau,parametres);
prediction = testSVM;
perf = length(find(sign(donnees.testlab)==sign(prediction)))/length(prediction);
fprintf(1,'performance en test: %2.2f \n',100*perf);

%  figure;
%  hold on;
[xtesta1,xtesta2]=meshgrid([-.5:0.01:1],[-.5:0.01:1]);
[na,nb]=size(xtesta1);
 xtest1=reshape(xtesta1,1,na*nb);
 xtest2=reshape(xtesta2,1,na*nb);
 xtest=[xtest1;xtest2];
 svModel.data.testvec = xtest;
 ypred = testSVM;
%  %[ypred,maxi]=OnLineSVM_1vs_all_val(d,alpha,pos,nbsv,b,yapp,xtest',xapp);
  ypredmat=reshape(ypred,na,nb);
  contourf(xtesta1,xtesta2,ypredmat,30);shading flat
  hold on
  [cs,h]=contour(xtesta1,xtesta2,ypredmat,[0 1],'k');
  clabel(cs,h);
%  plot(donnees.trainvec(1,find(donnees.trainlab==1)),donnees.trainvec(2,find(donnees.trainlab==1)),'rx');
%  % plot(donnees.trainvec(1,find(donnees.trainlab==-1)),donnees.trainvec(2,find(donnees.trainlab==-1)),'bx');
%  % axis([-2 2 -2 2]);
%  hold off;


plot(donnees.trainvec(1,find(donnees.trainlab==1)),donnees.trainvec(2,find(donnees.trainlab==1)),'bx');
% hold on;
plot(donnees.trainvec(1,svModel.model.indices{1}),donnees.trainvec(2,svModel.model.indices{1}),'bo');
plot(donnees.testvec(1,find(donnees.testlab==-1)),donnees.testvec(2,find(donnees.testlab==-1)),'ro');
plot(donnees.testvec(1,find(donnees.testlab==1)),donnees.testvec(2,find(donnees.testlab==1)),'go');
%plot(donnees.testvec(1,find(sign(prediction)==-1)),donnees.testvec(2,find(sign(prediction)==-1)),'rx');
%plot(donnees.testvec(1,find(sign(prediction)==1)),donnees.testvec(2,find(sign(prediction)==1)),'gx');
legend('support line 0','support line 1','learning data','support vectors','not in the classe - truth','in the class - truth',0);%'not in the classe','in the class',0);
title('One Class SVM');
hold off;




