clear all;
global svModel;
t1 = cputime;
%--------------------------------------------------

[train_patterns, vide] = readidx('../../../../database/mnist/train-images-idx3-ubyte',60000,60000);
[train_labels, vide] = readidx('../../../../database/mnist/train-labels-idx1-ubyte',60000,60000);
[test_patterns, vide] = readidx('../../../../database/mnist/t10k-images-idx3-ubyte',10000,10000);
[test_labels, vide] = readidx('../../../../database/mnist/t10k-labels-idx1-ubyte',10000,10000);

fprintf('Les donnes sont lues\n');
for i=1:784
      test_patterns(i,:) = (test_patterns(i,:)./128)-1;
      train_patterns(i,:) = (train_patterns(i,:)./128)-1;
end
fprintf('Les donnes sont normalises\n');
%  % supprimer le cadre blanc
%  ad = [];
%  b = 2;
%  a = b*28;
%  for i = 1:28-2*b
%        ad = [ad,a+b+1:a+28-b];
%        a = a+28;
%  end
%  train_patterns = train_patterns(ad,:);  
%  test_patterns = test_patterns(ad,:);



donnees = data(train_patterns, train_labels', test_patterns, test_labels');
clear train_patterns;
clear train_labels;
clear test_patterns;
clear test_labels;
multiclass = '1vsall';
%-----------------------------------------------------
%   Learning Parameters
C = 20;
p = [5,0.03];
ker= 'poly';
tolerance = 1e-5;
pas = 100;
meth = 'chol';
parametres = param(C,pas,multiclass,meth,tolerance);
noyau = kernel(ker,p);
%-----------------------------------------------------
% Learning and testing 1vs1
fprintf('Je rentre dans le SVM MultiClasses 1 contre all\n');
trainSVM(donnees,noyau,parametres);
clear donnees;
prediction = testSVM;
%perf = length(find(svModel.data.testlab==prediction(:,1)))/length(prediction);
% fprintf(1,'performance en test: %2.2f \n',100*perf);

%-----------------------------------------------------
% Learning and testing 1vsAll
%  svmMultiClassOneAgainstAll(donnees,noyau,parametres);
%  prediction = testSVM;
perf = length(find(donnees.testlab==prediction))/length(prediction);
fprintf(1,'performance en test: %2.2f \n',100*perf);
t2 = cputime-t1

