clear all;
global svModel;
profile on;
t1 = cputime;
%--------------------------------------------------

load ../database/usps_perm.mat
[rien,train_labels] = max(train_labels,[],1);
[rien,test_labels] = max(test_labels,[],1);
donnees = data(train_patterns, train_labels', test_patterns, test_labels');
clear train_patterns;
clear train_labels;
clear test_patterns;
clear test_labels;
multiclass = '1vsall';
type = 'invariant';
transformations = 1:13;
% transformations = [];
%-----------------------------------------------------
%   Learning Parameters
C = 0.00001;
p = [5,0.2];
ker= 'poly';
tolerance = 1e-5;
pas = 100;
meth = 'qr';
parametres = param(C,pas,multiclass,meth,tolerance,type,transformations);
noyau = kernel(ker,p);
%-----------------------------------------------------
% Learning and testing 1vs1
trainSVM(donnees,noyau,parametres);
prediction = testSVM;
perf = length(find(donnees.testlab==prediction(:,1)))/length(prediction);
%perf = length(find(donnees.testlab==prediction))/length(prediction);
fprintf(1,'performance en test: %2.2f \n',100*perf);
t2 = cputime-t1
profile report;
