function d = model(iclass,alpha,indices,mu,G1,G2);

if nargin>6
    error('Too many input arguments');
end
if nargin<1
    d.iclass=1;
    d.alpha = cell(d.iclass,1); % nbclassifier vectors of lagrangian coef
    d.indices = cell(d.iclass,1); % nbclassifier vectors of indices in the dataset 
    d.mu = cell(d.iclass,1); % nbclassifier scalar or vector (if span) of offset
    d.G1 = cell(d.iclass,1); % nbclassifier kernel matrix (inv(H) or Q)
    d.G2 = cell(d.iclass,1); % nbclassifier kernel matrix complement (R)
end
if nargin ==1
    d.iclass = iclass; % number of the current classifier
    d.alpha = cell(d.iclass,1); % nbclassifier vectors of lagrangian coef
    d.indices = cell(d.iclass,1); % nbclassifier vectors of indices in the dataset 
    d.mu = cell(d.iclass,1); % nbclassifier scalar or vector (if span) of offset
    d.G1 = cell(d.iclass,1); % nbclassifier kernel matrix (inv(H) or Q)
    d.G2 = cell(d.iclass,1); % nbclassifier kernel matrix complement (R)
end

if nargin==2
    d.iclass = iclass; % number of the current classifier
    d.alpha = alpha;
    d.indices = cell(d.iclass,1); % nbclassifier vectors of indices in the dataset
    d.mu = cell(d.iclass,1); % nbclassifier scalar or vector (if span) of offset
    d.G1 = cell(d.iclass,1); % nbclassifier kernel matrix (inv(H) or Q)
    d.G2 = cell(d.iclass,1); % nbclassifier kernel matrix complement (R)
end
if nargin==3
    d.iclass = iclass; % number of the current classifier
    d.alpha = alpha;
    d.indices = indices;
    d.mu = cell(d.iclass,1); % nbclassifier scalar or vector (if span) of offset
    d.G1 = cell(d.iclass,1); % nbclassifier kernel matrix (inv(H) or Q)
    d.G2 = cell(d.iclass,1); % nbclassifier kernel matrix complement (R)
end
if nargin==4
    d.iclass = iclass; % number of the current classifier
    d.alpha = alpha;
    d.indices = indices;
    d.mu = mu;
    d.G1 = cell(d.iclass,1); % nbclassifier kernel matrix (inv(H) or Q)
    d.G2 = cell(d.iclass,1); % nbclassifier kernel matrix complement (R)
end
if nargin==5
    d.iclass = iclass; % number of the current classifier
    d.alpha = alpha;
    d.indices = indices;
    d.mu = mu;
    d.G1 = G1;
    d.G2 = cell(d.iclass,1); % nbclassifier kernel matrix complement (R)
end
if nargin==6
    d.iclass = iclass; % number of the current classifier
    d.alpha = alpha;
    d.indices = indices;
    d.mu = mu;
    d.G1 = G1;
    d.G2 = G2;
end
d.nbC = 0;
% d.iclass = 1;
