function svmMultiClassOneAgainstAll(dataInput, kernelInput, paramInput, modelInput)

%=============================
% checking input
if nargin>4
	error('too many input arguments');
end
if nargin<2
	error('missing argument');
end


labelMax = max(dataInput.trainlab);
labelMin = min(dataInput.trainlab);
nbclass = labelMax-labelMin+1;

if nargin<=3
	modelInput = model(nbclass);
end
if nargin<=2
	paramInput = param;
end
%=============================


global svModel;
global temporarelyDataNeeded;

dataInput.trainlab_t = dataInput.trainlab;
for i = labelMin:labelMax
	dataInput.trainlab = dataInput.trainlab_t;
	dataInput.trainlab(dataInput.trainlab==i) = -1;
	dataInput.trainlab(dataInput.trainlab>=0) = 1;
	trainSVM(dataInput,kernelInput,paramInput,modelInput);
	svModel.model.iclass = svModel.model.iclass+1;
	svModel.param.C = paramInput.C;
	clear global temporarelyDataNeeded;
end