function testNuSvm(nbapp,nbtest)

clear global svModel;
global svModel;
%--------------------------------------------------
n='checkers';
% rand('seed',0);
[x,y,xt,yt,xtt,ytt] = dataset(n,nbapp,nbtest);
donnees = data(x,y,xt,yt);
clear x;
clear y;
clear xt;
clear yt;
clear xtt;
clear ytt;
multiclass='';


%-----------------------------------------------------
%   Learning Parameters
C = 1;
p = [2];
ker= 'rbf';
tolerance = 1e-5;
pas = 10;
noyau = kernel(ker,p);

meth = {'qr','chol','shmo'};
parametres = param(C,pas,multiclass,meth{1},tolerance,'nusvm');
i = 0;
for nu = 0.1:0.1:0.9
    i = i+1;
    parametres.nu = nu;
    %-----------------------------------------------------
    % Learning and testing
    if exist('svModel.mode')
    	trainSVM(donnees,noyau,parametres,svModel.model);
    else
    	trainSVM(donnees,noyau,parametres);
    end
    prediction = testSVM;
    perf = length(find(sign(donnees.testlab)==sign(prediction)))/length(prediction);
    fprintf(1,'performance en test: %2.2f \n',100*perf);
     sum(abs(svModel.model.alpha{1}))
    %svModel.model.alpha{1}
    %figure;
    subplot(3,3,i);
    hold on;
    [xtesta1,xtesta2]=meshgrid([-2:0.05:2],[-2:0.05:2]);
    [na,nb]=size(xtesta1);
    xtest1=reshape(xtesta1,1,na*nb);
    xtest2=reshape(xtesta2,1,na*nb);
    xtest=[xtest1;xtest2];
    svModel.data.testvec = xtest;
    ypred = testSVM;
    %[ypred,maxi]=OnLineSVM_1vs_all_val(d,alpha,pos,nbsv,b,yapp,xtest',xapp);
    ypredmat=reshape(ypred,na,nb);
    contourf(xtesta1,xtesta2,ypredmat,30);shading flat
    hold on
    [cs,h]=contour(xtesta1,xtesta2,ypredmat,[-cell2mat(svModel.model.gamma) 0 cell2mat(svModel.model.gamma)],'k');
    %clabel(cs,h);
    plot(donnees.trainvec(1,find(donnees.trainlab==1)),donnees.trainvec(2,find(donnees.trainlab==1)),'rx');
    plot(donnees.trainvec(1,find(donnees.trainlab==-1)),donnees.trainvec(2,find(donnees.trainlab==-1)),'bx');
        h1 = plot(donnees.trainvec(1,svModel.model.indices{1}),donnees.trainvec(2,svModel.model.indices{1}),'rs');
	set(h1,'LineWidth',3);
	colormap('gray');
    %plot(donnees.testvec(1,:),donnees.testvec(2,:),'og');
    axis([-2 2 -2 2]);
    hold off;
    
end
%clear all

