%close all
global svModel;
randn('state',0);
rand('state',0);
%--------------------------------------------------
%n='multiclassgaussian';
% n = 'checkers';
n ='clowns' 
nbapp = 100;
nbtest = 500;
[xapp,yapp,xt,yt]=dataset(n,nbapp,nbtest,1.5);

SS = 2;
[xtesta1,xtesta2]=meshgrid([-SS:0.02:SS],[-SS:0.02:SS]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2];
donnees = data(xapp,yapp,xtest);
%-----------------------------------------------------
%   Learning and Learning Parameters
C = 100;

p = .1;
ker = 'rbf';
noyau = kernel(ker,p);
tolerance = 1e-7;
pas = 100;
multiclass = '';
method='chol';
parametres = param(C,pas,multiclass,method,tolerance);
parametres.type='uncertain';
parametres.uncertainty = [100,0.2];

tic
trainSVM(donnees,noyau,parametres);
toc
[ypred]=testSVM;

svModel.data.testvec = xt;
result=testSVM;
perf = length(find(sign(result)==yt))/length(yt)

ypredmat=reshape(ypred,na,nb);
figure;
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');
clabel(cs,h);
h1=plot(xapp(1,yapp==-1),xapp(2,yapp==-1),'*c'); set(h1,'LineWidth',4);
h1=plot(xapp(1,yapp==1),xapp(2,yapp==1),'*m'); set(h1,'LineWidth',4);
% svModel.model.indices{1}
% xapp(:,svModel.model.indices{1})
h1=plot(svModel.data.trainvec(1,svModel.model.indices{1}(find(svModel.model.indices{1}<=nbapp))),...
    svModel.data.trainvec(2,svModel.model.indices{1}(find(svModel.model.indices{1}<=nbapp))),'ro');
set(h1,'LineWidth',2);
h1=plot(svModel.data.trainvec(1,svModel.model.indices{1}(find(svModel.model.indices{1}>nbapp))),...
    svModel.data.trainvec(2,svModel.model.indices{1}(find(svModel.model.indices{1}>nbapp))),'bo');
set(h1,'LineWidth',2);
%set(h1,'LineWidth',3);
%axis( [ -2 2 -2 2]);
colormap(gray);
title(['Carpette Problem with VO, noyau ',ker,' avec \gamma=',num2str(p)]);
hold off




